<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 2.5.00  
* Copyright (C) 2007: Fred Stuurman (fc.stuurman@hccnet.nl)
* Mailpage module: 
* mailpage.php: last changed 12/04/2007 by Fred Stuurman (fc.stuurman@hccnet.nl)
* $Id$
* Multiple file upload applet postlet used is from http://sourceforge.net/projects/postlet/
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/
if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}

//initialize vars
$fullname = "";
$message = "";
$email = "";
$modoption = "show_form";	//default choice for switch

if (IsSet ($_GET['modoption']))
{
	$modoption = sanitize($_GET['modoption'], 15, 'A');
}

//id used for the dropdown selection menu to select the contact person
if (IsSet ($_GET['contact_id']))
{
	$contact_id = sanitize($_GET['contact_id'], 5 , 'I');
}

if (IsSet ($_POST['fullname']))
{
	$fullname = sanitize($_POST['fullname'], 60 , 'S'); //sanitize the input
}

if (IsSet ($_POST['message']))
{
	$message = sanitize($_POST['message'], 1000 , 'S'); //sanitize the input
}

if (IsSet ($_POST['email']))
{
	$email = sanitize($_POST['email'], 80 , 'A'); //sanitize the input, max 80 characters
	$email = explode(",", $email); //if more than one email is entered
	$email = $email[0]; //ony use the first one.
}

$table_email_adresses = $dbprefix . "m_mail_address";

load_language($cmsdir . '/', 'sn_mailpage'); //load language file

if (IsSet ($contact_id))
{
	$query = "SELECT name, description, email, welcometext, thankyoutext, id " .
			"FROM $table_email_adresses WHERE id = '".$contact_id."'";
}
else
{
	$query = "SELECT name, description, email, welcometext, thankyoutext, id " .
			"FROM $table_email_adresses ORDER BY sort LIMIT 1";
}

$result = mysql_query($query) or trigger_error(mysql_error().'"<br/>Query : "' . $query . '".',E_USER_WARNING); 
$RecordCount = mysql_num_rows($result);

if ($RecordCount > 0)
{ //if table is empty use old email from config table
	$contact_name = mysql_result($result, 0, 0); //address from config table.
	$contact_description = mysql_result($result, 0, 1);
	$contact_email = mysql_result($result, 0, 2);
	$contact_welcome_text = mysql_result($result, 0, 3);
	$contact_thankyou_text = mysql_result($result, 0, 4);
	$contact_id = mysql_result($result, 0, 5);
}
else
{
	$contact_name = "";
	$contact_description = "";
	$contact_email = $sas_config['email'];
	$contact_welcome_text = $sas_config['email_text'];
	$contact_thankyou_text = $sas_config['email_thankyou_text'];
}
unset ($query);
unset ($result);

switch ($modoption) // start of switch
{
	case send_email :
		
		//try to prevent spam postings
		//if the submit_check_code stored in the session is equal to the one submitted
		//we allow submission
		if ($_POST['submit_check_code'] != $_SESSION['submit_check_code']) 
		{
		   print "<span class=\"sas_module_error\">".$sas_lang['invalid_submission']."</span>";
		   exit;
		}
		
		$submitted_time_key = $pagetitle . "_submitted_time";
		if (IsSet ($_SESSION[$submitted_time_key]))
		{
			//we have had a previous submit from this session and page
			//calculate how many seconds ago and
			//allow submission if the last submission is not longer than 5 minutes ago.
			$delta_time = time() - $_SESSION[$submitted_time_key] ; 
			if ($delta_time < 300)
			{
				print "<span class=\"sas_module_error\">".$sas_lang['invalid_submission']."</span>";
				exit;
			}
		}

		$send_message = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"
					\"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">
					<html>
					<head>
					<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . $sas_lang['lang_charset'] . "\">
					<title>".$sas_lang['email_module_email']."</title>
					</head>
					<body>
					<table>
					<tr><td><b>".$sas_lang['email_module_to'].":</b></td><td>$contact_name</td></tr>
					<tr><td width='8%'><b>".$sas_lang['email_module_name']."</b></td><td>$fullname</td></tr>
					<tr><td><b>".$sas_lang['email_module_email']."</td><td>$email</td></tr>
					<tr><td valign=\"top\"><b>".$sas_lang['email_module_text']."</b></td><td>$message</td></tr>
					<tr><td valign=\"top\"><b>IP:</td><td>$ip</b></td></tr>
					</table><br/><br/>
					</body></html>";

		require ($cmsdir."/core/class.phpmailer.php"); //use the phpmailer class
		$mail = new PHPMailer();
		$mail->From = $email; //email address of submitter
		$mail->FromName = $sitename;
		$mail->Subject = $sas_lang['email_module_email_from'] . " " . $fullname . " - $email";
		$mail->Body = $send_message;
		$mail->IsHTML(true);
		$mail->AddAddress($contact_email); //add email address owner form.
		$mail->Send();

		//put submitted data in a session vars to display the result page.
		$_SESSION['submitted_contact_name'] = $contact_name ;
		$_SESSION['submitted_email'] = $email ;
		$_SESSION['submitted_message'] = $message ;
		$_SESSION['submitted_full_name'] = $fullname ;

		$_SESSION['submit_check_code'] = "" ; //clear the code so it cannot be used again!
		$_SESSION[$submitted_time_key] = time(); //record the time of this submission for this page
		//go to display the result page
		print "<script type=\"text/javascript\">window.location = 'index.php?section=$section&page=$page&modoption=display_result'</script>";

	break;

	case display_result :
	
		print 
			"<table class=\"sas_module_table\"><tr>
			<td colspan=\"3\"><span class=\"sas_module_lbl1\">".$sas_lang['email_module_sent_us']."</span></td>
			</tr>
			<tr>
			<td colspan=\"3\">&nbsp;</td></tr>
			<tr>
			<td width='25%'><span class=\"sas_module_lbl1\">".$sas_lang['email_module_to'].":</span></td>
			<td><span class=\"sas_module_text\">".$_SESSION['submitted_contact_name']."</span></td>
			</tr><tr>
			<td><span class=\"sas_module_lbl1\">".$sas_lang['email_module_name']."</span></td>
			<td><span class=\"sas_module_text\">".$_SESSION['submitted_full_name']."</span></td>
			</tr><tr>
			<td><span class=\"sas_module_lbl1\">".$sas_lang['email_module_email']."</span></td>
			<td><span class=\"sas_module_text\">".$_SESSION['submitted_email']."</span></td>
			</tr><tr>
			<td valign=\"top\"><span class=\"sas_module_lbl1\">".$sas_lang['email_module_text']."</span></td>
			<td><span class=\"sas_module_text\">".$_SESSION['submitted_message']."</span></td>
			</tr>
			</table><br/><br/><span class=\"sas_module_subtitle\">";
			
		if ($contact_thankyou_text == "")
		{
			print $sas_config['email_thankyou_text'];
		}
		else
		{
			print $contact_thankyou_text;
		}
		unset($_SESSION['submitted_message']);	//clear session variable
		unset($_SESSION['submitted_contact_name']);
		unset($_SESSION['submitted_email']);
		unset($_SESSION['submitted_full_name']);
		
		print "</span><br/><br/><form action=\"\">
				<input type=\"button\" value=\"".$sas_lang['goback']."\" name=\"backbutton\"
				onclick=\"parent.location='index.php?section=$section&amp;page=$page'\" class=\"backbutton\"/></form>";
	break;
	
	case show_form :
	
		//set a code in a session var which is checked at submit time.
		$submit_check_code = random_code(10) ;
		$_SESSION['submit_check_code'] = $submit_check_code ;
		$query = "SELECT id, name, description FROM $table_email_adresses ORDER BY sort";
		$result = mysql_query($query) or trigger_error(mysql_error().'"<br/>Query : "' . $query . '".',E_USER_WARNING); 
	
		print "
<script type=\"text/javascript\">
<!--
	function ViewCrossReference (selSelectObject){
		if (selSelectObject.options[selSelectObject.selectedIndex].value != '')
		{
		location.href=selSelectObject.options[selSelectObject.selectedIndex].value
		}
	}

function checkinput ( form )
{  
	var filter  = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
	
	if (form.fullname.value == '')
	{
	alert( \"$sas_lang[email_module_noname_error]\" );
	form.fullname.focus();
	return false ;
	}
	if (form.email.value == '')
	{
	alert( \"$sas_lang[email_module_noemail_error]\" );
	form.email.focus();
	return false ;
	}
	
	if (!filter.test(form.email.value)) 
	{
	alert( \"$sas_lang[email_module_noemail_error]\" );
	return false ;
	}
	if (form.message.value == '')
	{
	alert( \"$sas_lang[email_module_nomessage_error]\" );
	form.message.focus();
	return false ;
	}

  return true ;
}
//-->
</script>";
	
		print "<form method=\"post\" action=\"index.php?section=$section&amp;page=$page&amp;contact_id=$contact_id&amp;modoption=send_email\" onsubmit=\"return checkinput(this);\"/>";
		print "<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" class=\"sas_module_table\">
			  <tr><td><span class=\"sas_module_title\">";
		if ($contact_welcome_text == "")
		{
			print $sas_config['email_text'];
		}
		else
		{
			print $contact_welcome_text;
		}
		print "</span></td></tr>
		  <tr><td>&nbsp;</td></tr>
		  <tr>
			<td width=\"100%\">
			  <table cellspacing=\"0\" cellpadding=\"0\" border=\"0\">";
	
		if ($RecordCount > 0)
		{
			print "  <tr>
					<td colspan=\"3\"><span class=\"sas_module_lbl1\">" . $sas_lang['email_module_select_contact'] . 
					": <select name=\"contact_id_selected\" onchange=\"ViewCrossReference(this);\">";
			
			while ($address_list = mysql_fetch_array($result))
			{
				if ($contact_name == $address_list[1])
				{
					print "<option value=\"index.php?section=$section&amp;page=$page&amp;contact_id=$address_list[0]\" selected=\"selected\">$address_list[1]</option>";
				}
				else
				{
					print "<option value=\"index.php?section=$section&amp;page=$page&amp;contact_id=$address_list[0]\">$address_list[1]</option>";
				}
			}
			print "</select></span></td>
				</tr>
				<tr><td colspan=\"3\">&nbsp;</td></tr>
				<tr><td colspan=\"3\"><span class=\"sas_module_subtitle\">$contact_description</span></td></tr>";
		}
		print "<tr><td colspan=\"3\">&nbsp;</td>
				</tr>
				<tr>
				  <td valign=\"top\" width=\"25%\" align=\"right\"><span class=\"sas_module_lbl1\">".$sas_lang['email_module_name']." (*)&nbsp;</span></td>
				  <td valign=\"top\"><input class=\"sas_module_input\" size=\"50\" name=\"fullname\" value=\"$fullname\"/><br/>&nbsp;</td>
				  <td rowspan=\"2\" valign=\"top\">";
	
		if (file_exists($sas_config['email_picture']))
		{
			print "<img border=\"0\" alt=\"email logo\" src=\"" . $sas_config['email_picture'] . "\"/>";
		}
	
		print "&nbsp;</td>
				  </tr>
				<tr>
				  <td valign=\"top\" width=\"25%\" align=\"right\" height=\"50\"><span class=\"sas_module_lbl1\">".$sas_lang['email_module_email']." (*)&nbsp;</span></td>
				  <td valign=\"top\" colspan=\"2\"><input class=\"sas_module_input\" size=\"50\" name=\"email\" value=\"$email\"/><br/>&nbsp;</td>
				  </tr>
				<tr>
				  <td valign=\"top\" width=\"25%\" align=\"right\"><span class=\"sas_module_lbl1\">".$sas_lang['email_module_text']." (*)&nbsp;</span></td>
				  <td valign=\"top\" colspan=\"2\"><textarea class=\"sas_module_input\" name=\"message\" rows=\"9\" cols=\"40\">$message</textarea></td></tr>  
				<tr><td colspan=\"3\">&nbsp;</td></tr>
				<tr>
				  <td>&nbsp;</td>
				  <td colspan=\"2\"><span class=\"sas_module_lbl2\">".$sas_lang['required_fields']."</span></td>
				  </tr>
				<tr>
				  <td valign=\"top\" width=\"25%\">&nbsp;</td>
				  <td valign=\"top\" colspan=\"2\">
					 <br/><br/><input type=\"hidden\" name=\"contact_id\" id=\"contact_id\" value=\"$contact_id\"/>
					 <input type=\"hidden\" id=\"submit_check_code\" name=\"submit_check_code\" value=\"$submit_check_code\"/>
					 <input type=\"submit\" value=\"" . $sas_lang['email_module_send'] . "\" id=\"B1\" name=\"B1\"/></td>
				  </tr>
			</table><br/></td>
			</tr></table>";
	break;
}
?>