<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 2.5.00  
* Copyright (C) 2007: Fred Stuurman (fc.stuurman@hccnet.nl)
* Class pages module : 
*  user_login.php: last changed 02/05/2007  by Fred Stuurman (fc.stuurman@hccnet.nl)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/
if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}

//teacher
if (IsSet ($_REQUEST['fullname']))
{
	$fullname = $_REQUEST['fullname'];
	$fullname = htmlspecialchars(strip_tags($fullname)); //remove html tags
}
if (IsSet ($_POST['username']))
{
	$username = $_POST['username'];
	$username = htmlspecialchars(strip_tags($username)); //remove html tags
}
if (IsSet ($_POST['password']))
{
	$password = $_POST['password'];
	$password = htmlspecialchars(strip_tags($password)); //remove html tags
}
if (IsSet ($_POST['class1']))
{
	$class1 = intval($_POST['class1']);
}
if (IsSet ($_REQUEST['new_class']))
{
	$new_class = intval($_REQUEST['new_class']);
}
if (IsSet ($_POST['email']))
{
	$email = $_POST['email'];
	$email = htmlspecialchars(strip_tags($email)); //remove html tags
}
if (IsSet ($_POST['check']))
{
	$check = $_POST['check'];
}
if (IsSet ($_POST['send_email']))
{
	$send_email = $_POST['send_email'];
}
if (IsSet ($_POST['invisible']))
{
	$invisible = intval($_POST['invisible']);
}
if (IsSet ($_GET['student_id']))
{
	$student_id = intval($_GET['student_id']);
}

if (IsSet ($_REQUEST['option']))
{
	$option = $_REQUEST['option'];
	$option = htmlspecialchars(strip_tags($option)); //remove html tags
}

//student
if (IsSet ($_POST['title']))
{
	$title = sanitize($_POST['title'], 50 , 'S');
}
if (IsSet ($_POST['order']))
{
	$order = intval($_POST['order']);
}
$d = date("Y-m-d"); //todays date

if (IsSet ($_POST['newcontent']))
{
	$newcontent = sql_addslashes($_POST['newcontent']);
}

if ((IsSet ($option)) AND (($option == "userlogin") OR ($option == "save_new_password")))
{
	if (!verify_logon($_POST['user_username'], $_POST['user_password'], "no_admin", $option))
	{
		print "<script language=\"Javascript\">
			   <!--
			   alert (\"" . $sas_lang['login_error'] . "\");
			   window.location = 'index.php?section=$section&amp;page=$page' ;	
			   //-->
			   </script>";
	}
}
elseif (!IsSet ($_SESSION['userid']))
{
	if (IsSet ($_GET['username']))
	{
		$username = $_GET['username'];
	}

	if ($_GET['error'] == "true")
	{
		print "<script language=\"Javascript\">
			   <!--
			   alert (\"" . $sas_lang['password_change_problem'] . "\");
			   //-->
			   </script>";
	}
	elseif ($option == "new_password") //passwords reset
	{
		print "<script language=\"Javascript\">
			   <!--
			   alert (\"" . $sas_lang['password_need_change'] . "\");
			   //-->
			   </script>";
	}

print "<script type=\"text/javascript\">

/*<![CDATA[*/

function checkinput ( form )
{
    if (form.user_password.value == '') 
    {
    alert( \"".$sas_lang['input_error']."\" );
    form.user_password.focus();
    return false ;
    }
    if (form.password_new1.value == '') 
    {
    alert( \"".$sas_lang['input_error']."\" );
    form.password_new1.focus();
    return false ;
    }
    if (form.password_new1.value.length < 4) 
	{
    alert( \"".$sas_lang['password_length_error']."\" );
    form.password_new1.focus();
    return false ;
    }
	if (form.password_new2.value == '') 
    {
    alert( \"".$sas_lang['input_error']."\" );
    form.password_new2.focus();
    return false ;
    }
    if (form.password_new2.value.length < 4) 
	{
    alert( \"".$sas_lang['password_length_error']."\" );
    form.password_new2.focus();
    return false ;
    }
  return true ;
}
/*]]>*/

</script>";

	print "<table cellpadding=\"4\"><tr><td colspan=\"2\">" . $sas_lang['login_text'] . "</td></tr>\n";
	print "<tr><td><form method=\"post\" action=\"index.php?section=$section&amp;page=$page\" onsubmit=\"return checkinput(this);\"/></td></tr>\n";

	print "<tr><td align=\"right\"><b>" . $sas_lang['username'] . " :</b></td>
		<td><input tabindex=\"1\" type=\"text\" name=\"user_username\" size=\"25\" value=\"$username\"/></td></tr>\n
		<tr><td align=\"right\"><b>" . $sas_lang['password'] . " :</b></td>
		<td><input tabindex=\"2\" type=\"password\" name=\"user_password\" size=\"25\"/></td></tr>\n";
				 
	if ($option == "new_password") //passwords reset
	{
		print "<tr><td>&nbsp;</td></tr><tr><td align=right><b>" . $sas_lang['password_new'] . ":</b></td></tr>
			     <tr><td align=right><b>" . $sas_lang['password'] . "1:&nbsp;</b></td>
			     <td> <input type=\"password\" tabindex=\"3\" name=\"password_new1\" size=\"25\"></td>
				</tr>\n
				<tr>
			     <td align=right><b>" . $sas_lang['password'] . "2:&nbsp;</b></td>
			     <td> <input type=\"password\" tabindex=\"4\" name=\"password_new2\" size=\"25\"/>
				 <input type=\"hidden\" name=\"option\" value=\"save_new_password\"/></td>
				</tr>\n";
	}
	if ($option != "new_password") //passwords reset
	{
		print "<tr>
			   <td>&nbsp;</td>
			   <td><a href=\"$cmsdir/sendpw.php?option=public\">" . $sas_lang['logged_password_forget'] . "</a>\n
			   <input type=\"hidden\" name=\"option\" value=\"userlogin\"/>
				</td>       
				</tr>";
	}
	print "<tr>
			<td colspan=\"2\" align=\"right\"><input tabindex=\"5\" type=\"submit\" value=\"" . $sas_lang['login'] . "\"/></td>\n
			</tr></table>\n";
}

if (IsSet ($_SESSION['usertype']))
{
	$usertype = $_SESSION['usertype'];
}
else
{
	$usertype = "";
}
if (IsSet ($_SESSION['userid']))
{
	$userid = $_SESSION['userid'];
}

if ($usertype == "student")
{
	include ("$cmsdir/modules/sn_studentpages/student.php");
}
if ($usertype == "teacher")
{
	include ("$cmsdir/modules/sn_studentpages/teacher.php");
}
?>